#include <iostream.h>
#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <fstream>
#include <string.h>

#include <gl.h>
#include <glu.h>

#include <SDL/SDL.h>
#include <SDL/SDL_ttf.h>
#include <SDL/SDL_image.h>
#include <SDL/SDL_mixer.h>

#include "graph.h"

using namespace std;//ХЗ что это но с ним заработал строковый тип string

//Раздел констант
const 
 int win_DX=1024,//размеры окна по X
     win_DY=768,//размеры окна по Y
     grid=32,//размер ячейки сетки уровня

     lev_width=32,//размеры уровня по X
     lev_height=24,//размеры уровня по Y
     lev_num_max=lev_width*lev_height,//максимальное количество элементов уровня
     obj_num_max=lev_width*lev_height,//максимальное количество объектов

     eff_num_max=99;//максимальное количество эффектов

//аналог Record из delphi
struct lev_type //сетка уровня
 { 
  int x,
      y,
      texture,
      exit_score;
 }
lev[lev_num_max];

struct obj_type //сетка объектов
 { 
  int x,
      y,
      texture;
 }
obj[obj_num_max];

//переменные колобка
int p_x,//координаты колобка
    p_y, 
    p_move_x,//смещение колобка по OX
    p_move_y,//смещение колобка по OY
    p_vector,//вектор направления движения
    p_vector_nuke,//вектор направления взгляда при попытке взрыва
    p_vector_old_left_right,//старое напр. движения влево или вправо для анимации вверх или вниз
    p_frame,//кадр колобка
    p_frame_count,//временной счетчик между кадрами анимации
    p_move_stage,//стадия управления движением колобка
    p_kick_left_obj_N,//индекс тычкнутого объекта слева
    p_kick_right_obj_N,//индекс тычкнутого объекта справа
    p_score,//количесвто очков
    p_live,//количесвто жизней
    p_kal[lev_num_max];//остатки от печатных плат (1-го типа lev[]) 

bool p_move_left = false,
     p_move_right = false,
     p_move_up = false,   
     p_move_down = false,
     p_move_left_v = false, 
     p_move_right_v = false,     
     p_move_up_v = false,     
     p_move_down_v = false, 
     p_kick_left = false, 
     p_kick_right = false,
     p_true;// жив ли колобок


//переменные динамических объектов
int obj_index[obj_num_max],//индекс объекта
    obj_move_x[obj_num_max],
    obj_move_y[obj_num_max],
    obj_delta[obj_num_max],
    obj_AI_rnd[obj_num_max],

    obj_rotate[obj_num_max],//определяет тип кручения объекта 1 - при движении, 2- все время
    obj_sleep_count[obj_num_max],//таймер покоя, после падения = 5,затем вычитается до 0
    
    obj_nuke_index,//просто индекс объекта
    obj_nuke_count[obj_num_max];

bool obj_move[obj_num_max],//объект движется
     obj_move_up[obj_num_max],
     obj_move_down[obj_num_max],
     obj_move_left[obj_num_max],
     obj_move_right[obj_num_max],
     obj_move_up_v[obj_num_max],//объект может двинутся вверх
     obj_move_down_v[obj_num_max],
     obj_move_left_v[obj_num_max],
     obj_move_right_v[obj_num_max],
     
     //для проверок на сваливаемость для элементов OBJ 1,2
     obj_move_up_left_v[obj_num_max],//вверх-влево
     obj_move_up_right_v[obj_num_max],//вверх-вправо
     obj_move_down_left_v[obj_num_max],//вниз-влево
     obj_move_down_right_v[obj_num_max],//вниз-вправо
     
     obj_move_kick_left_mark[obj_num_max],//отмечен для тычка слева
     obj_move_kick_right_mark[obj_num_max],//отмечен для тычка справа

     obj_dead[obj_num_max],//мертв ли объект
     obj_nuke[obj_num_max];// объект на подрыве
  

//переменные для контроля столкновений
int lev_matrix[lev_width+1][lev_height+1],//матрица уровня
    obj_matrix[lev_width+1][lev_height+1];//матрица объектов


int eff_x[eff_num_max],
    eff_y[eff_num_max],
    eff_type[eff_num_max],
    eff_W[eff_num_max],
    eff_H[eff_num_max],
    eff_cR[eff_num_max],
    eff_cG[eff_num_max],
    eff_cB[eff_num_max],
    eff_cAlpha[eff_num_max],
    
    eff_counter[eff_num_max];

bool eff_true[eff_num_max];


//переменные редактора
bool edit=false;//включен ли режим редактора

int x_cursor,//координаты курсора редактора
    y_cursor,
    num_texture,//индекс текстуры
    num_level,//номер уровня
    exit_score,
    delta,//курсор редактора крутиться
    edit_mode;//режим редактора:редактор уровня или редавтор объектов
    

//остальные переменные
int i,j,k,l,m,XL,YL;//переменные циклов

int x_cam,//координаты камеры
    y_cam;

char buff[200];//для загрузки всего

int done=0;//переменная отвечающая за окончание Великого рендера


char txt_tmp[25];//для цифр текста [колво символов]



SDL_Surface *screen,//Экран
            *surface; //SDL поверхность

SDL_Event event;// SDL событие
Uint8* keys;//для управления клавиатурой
FILE *fp;//для записи уровня

GLuint player_texture[20], //хэндл основных текстуры колобка
       obj_texture[10],//текстуры объектов
       lev_texture[9],//текстуры уровня
       other_texture[10],//остальные текстуры
       background_texture[4],//задний фон              
       cursor_texture,//текстура курсора для редактора 
       eff_texture[2][999];

void InitGame()
 {
 //параметры колобка при старте
  p_x=1;//место старта колобка
  p_y=1;
  p_frame=1;//стартовый кадр
  p_score=0;
  p_live=45;
  p_true=true;
  p_vector=1;   
  p_vector_nuke=2;
  p_vector_old_left_right=2;

//обнуление
  for(j=0; j < lev_width+1; j++)
  for(k=0; k < lev_height+1; k++)
   {
    obj_matrix[j][k]=0;
    lev_matrix[j][k]=0;
   }
/*
  for(i=0; i < lev_width*lev_height; i++)
   {
    lev[i].texture=0;
    lev[i].x=0;
    lev[i].y=0;
    lev[i].texture=0;
    lev[i].exit_score=0;

    obj[i].texture=0;
    obj[i].x=0;
    obj[i].y=0;
    obj[i].texture=0;
   }
*/
  x_cursor=0;
  y_cursor=0;
  num_texture=1;

 }

//Главный BEGIN
int main()
 {
  srand(time(NULL));//randomize; -включить счетчик случайных чисел <iostream.h>

//Инициализация SDL(видео) 
  if ( SDL_Init(SDL_INIT_VIDEO) != 0 ) 
   {
    printf("Unable to initialize SDL: %s\n", SDL_GetError());
    return 1;
   }

  SDL_GL_SetAttribute( SDL_GL_DOUBLEBUFFER, 1 );// ХЗ

  screen = SDL_SetVideoMode( win_DX, win_DY, 32, SDL_OPENGL/*|SDL_FULLSCREEN*/);//экран OpenGl
  if ( !screen ) 
   {
    printf("Unable to set video mode: %s\n", SDL_GetError());
    return 1;
   }

//Текст и иконка в титульнике окна программы
  SDL_WM_SetCaption("SupaPlex","splex");
  SDL_WM_SetIcon(SDL_LoadBMP("data/icon.bmp"), NULL);

//Цвет текста 
  SDL_Color txtColorRed = {255,0,0};
  SDL_Color txtColorGreen = {0,255,0};
  SDL_Color txtColorBlue = {0,0,255};
  SDL_Color txtColorWhite = {255,255,255};
  SDL_Color txtColorBlack = {0,0,0};

  TTF_Init();//инициализируем шрифт
  TTF_TextInit();
      
//    
  glGenTextures(1, &t_txt[1]);//не в цикле а то прогу можно убить
  glGenTextures(1, &t_txt[2]);//не в цикле а то прогу можно убить

//Устанавливаем режим 2D для OpenGL
  glClearColor( 0, 0, 0, 0 ); //задний цвет фона черный (R,G,B,alpha)
  glEnable( GL_TEXTURE_2D ); // надо для вывода текстуры
  gl2dMode (win_DX,win_DY);

 
//Включаем альфа канал
  glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
  glEnable(GL_BLEND);

//Загрузка текстур колобка
  for(i=1;i<8+1;i++)
   {
    sprintf(buff,"data/player/%i.png",i);
    load(buff, player_texture[i]);
   }

    //Загрузка других текстур
  load("data/other/kal.png", other_texture[1]);
  load("data/other/livebar.png", other_texture[2]);
  load("data/other/hud.png", other_texture[3]);

//Загрузка текстур объектов
  for(i=1;i<3+1;i++)
   {
    sprintf(buff,"data/obj/%i.png",i);
    load(buff, obj_texture[i]);
   }

//Загрузка текстур уровня
  for(i=1;i<5+1;i++)
   {
    sprintf(buff,"data/lev/%i.png",i);
    load(buff, lev_texture[i]);
   }
 
//Загрузка текстур эффектов
  for(i=1;i<20+1;i++)
   {
    sprintf(buff,"data/gfx/boom/%i.png",i);
    load(buff, eff_texture[1][i]);
   }

  for(i=1;i<16+1;i++)
   {
    sprintf(buff,"data/gfx/light/%i.png",i);
    load(buff, eff_texture[2][i]);
   }

//Загрузка заднего фона
  load("data/bground/3.jpg", background_texture[1]);

//Текстура курсора
  load("data/cursor.png", cursor_texture);

  InitGame();

  num_level=1;  
  edit_mode=1;

  InitFps();//инициализация ФПС
  
//загрузка уровня при старте-завязать с num_level
  
  sprintf(buff,"level/lev%i.dat",num_level);
  fp=fopen(buff,"r");
  fread((char *)lev, sizeof(struct lev_type), lev_num_max, fp);
  fclose (fp); 

  sprintf(buff,"level/obj%i.dat",num_level);
  fp=fopen(buff,"r");
  fread((char *)obj, sizeof(struct obj_type), obj_num_max, fp);
  fclose (fp);




/*
//hren4
int obj_old_x[obj_num_max],
    obj_old_y[obj_num_max];
//сохраняем местоположение
  for(j=0; j < obj_num_max; j++) 
   { 
    obj_old_x[j]=obj[j].x;
    obj_old_y[j]=obj[j].y;
   }
*/




//Очищаем экран перед рисованием
  glClear(GL_COLOR_BUFFER_BIT);

//Великий РЕНДЕР
  while(done == 0)
   {
 //Подсчет ФПС
    SolveFps();//подсчет ФПС, таймер
    Delay_by_Fps(40);

//!! cout вызывают тормоза в цикле
//    cout <<"fps=" << fps <<"\n";

//    cout << p_frame;//???? 555666555666555_6_555???


//обновляем матрицу уровня
     for(i=0; i < lev_num_max; i++) {lev_matrix[lev[i].x][lev[i].y]=lev[i].texture;}

//обновляем матрицу объектов    
/*   for(j=0; j < lev_width+1; j++)
     for(k=0; k < lev_height+1; k++)
      {
       obj_matrix[j][k]=0;
      }
*/
     for(j=0; j < obj_num_max; j++) 
      { 
       obj_index[j]=j;
       if (obj_dead[j]==false) {obj_matrix[obj[j].x][obj[j].y]=obj[j].texture;}
       if (obj_dead[j]==true) {obj_matrix[obj[j].x][obj[j].y]=0;}
      }



//Обрабатываем событие с клавиатуры
     while ( SDL_PollEvent(&event) )
      { 
       if (event.type==SDL_QUIT) {done=1;}//на выход по закрытию программы нажав на конпку на окне 
       if (event.type==SDL_KEYDOWN)//еcли нажата кнопка на клавиатуре
        {
         if (event.key.keysym.sym==SDLK_ESCAPE) {done=1;}//ESC
  
         if ( event.key.keysym.sym == SDLK_F1 ) {edit=not edit;} 

//блок управления редактором
         if (edit==true)
          {
//управление курсором
           if (event.key.keysym.sym==SDLK_w) {y_cursor=y_cursor-1;} 
           if (event.key.keysym.sym==SDLK_s) {y_cursor=y_cursor+1;} 
           if (event.key.keysym.sym==SDLK_a) {x_cursor=x_cursor-1;} 
           if (event.key.keysym.sym==SDLK_d) {x_cursor=x_cursor+1;}

//ограничение передвижения курсора по уровню
           if (x_cursor>=lev_width) {x_cursor=lev_width;} 
           if (x_cursor<=0) {x_cursor=0;}  
           if (y_cursor>=lev_height) {y_cursor=lev_height;} 
           if (y_cursor<=0) {y_cursor=0;}    

//переключение элементов уровня 
           if (event.key.keysym.sym==SDLK_q) {num_texture=num_texture+1;}
           if (event.key.keysym.sym==SDLK_e) {num_texture=num_texture-1;}

//прокручивание очков выхода 
           if (event.key.keysym.sym==SDLK_r) {exit_score=exit_score+1;}
           if (event.key.keysym.sym==SDLK_y) {exit_score=exit_score-1;}

//переключение номера уровня 
           if (event.key.keysym.sym==SDLK_u) {num_level=num_level+1;}
           if (event.key.keysym.sym==SDLK_i) {num_level=num_level-1;}

//происходит переключение режимов редактора
           if (event.key.keysym.sym==SDLK_F2) {edit_mode=1;}//статичные lev
           if (event.key.keysym.sym==SDLK_F3) {edit_mode=2;}//динамические obj

//устанавливаем элемент
           if (event.key.keysym.sym==SDLK_SPACE) 
            {
 
             if (edit_mode==1)//статичные lev
              {  
               for(i=0; i < lev_num_max; i++) 
                {
                 if (lev[i].texture==0 and 
                     lev_matrix[x_cursor][y_cursor]==0) 
                  {
                   lev[i].x=x_cursor;
                   lev[i].y=y_cursor;
                   lev[i].texture=num_texture;
                   if (lev[i].texture==2) {lev[i].exit_score=exit_score;}//выход
                   break;
                  }
                }
              }

             if (edit_mode==2)//динамические obj
              {  
               for(j=0; j < obj_num_max; j++) 
                {
                 if (obj[j].texture==0 and 
                     obj_matrix[x_cursor][y_cursor]==0) 
                  {
                   obj[j].x=x_cursor;
                   obj[j].y=y_cursor;
                   obj[j].texture=num_texture;
                   break;
                  }
                }
              }

            }//конец "устанавливаем элемент"

//стираем элемент
           if ( event.key.keysym.sym == SDLK_DELETE )
            { 
       
             if (edit_mode==1)//статичные lev
              {     
               for(i=0; i < lev_num_max; i++) 
                {
                 if (lev[i].texture>0 and lev[i].x==x_cursor and lev[i].y==y_cursor and
                     lev_matrix[x_cursor][y_cursor]==lev[i].texture) 
                  {
                   lev_matrix[x_cursor][y_cursor]=0;
                   if (lev[i].texture==2) {lev[i].exit_score=0;}//выход
                   lev[i].x=0;
                   lev[i].y=0;
                   lev[i].texture=0;
                   break;
                  }
                }
              }

             if (edit_mode==2)//динамические obj
              {     
               for(j=0; j < obj_num_max; j++) 
                {
                 if (obj[j].texture>0 and obj[j].x==x_cursor and obj[j].y==y_cursor and
                     obj_matrix[x_cursor][y_cursor]==obj[j].texture) 
                  {
                   obj_matrix[x_cursor][y_cursor]=0;
                   obj[j].x=0;
                   obj[j].y=0;
                   obj[j].texture=0;
                  
                   //чтобы не крутилось
                   obj_rotate[j]=0;
                   obj_delta[j]=0;
 
                   break;
                  }
                }
              }

            }//конец "стираем элемент"
  
          }//конец блока управления редактором
  
//блок управления вне ограничений режимов

//сохранение уровня
         if ( event.key.keysym.sym == SDLK_o )
          { 
           sprintf(buff,"level/lev%i.dat",num_level);
           fp=fopen(buff,"w");//статичные lev
           fwrite((char *)lev, sizeof(struct lev_type), lev_num_max, fp);
           fclose (fp); 

           sprintf(buff,"level/obj%i.dat",num_level);
           fp=fopen(buff,"w");//динамические obj
           fwrite((char *)obj, sizeof(struct obj_type), obj_num_max, fp);
           fclose (fp); 
          } 

//загрузка уровня
         if ( event.key.keysym.sym == SDLK_p )
           { 
            InitGame();

            sprintf(buff,"level/lev%i.dat",num_level);
            fp=fopen(buff,"r");
            fread((char *)lev, sizeof(struct lev_type), lev_num_max, fp);
            fclose (fp); 

            sprintf(buff,"level/obj%i.dat",num_level);
            fp=fopen(buff,"r");
            fread((char *)obj, sizeof(struct obj_type), obj_num_max, fp);
            fclose (fp);

           }


//блок управления игрой
         if (edit==false)
          {

           if ( event.key.keysym.sym == SDLK_l )//подраываем рядом стоящую бомбу
            {
             for(j=0; j < obj_num_max; j++) 
              {
               if (p_score>=10 and
                   obj[j].texture==2 and
                   obj_matrix[obj[j].x][obj[j].y]==obj[j].texture and
                   obj_dead[j]==false and
                   obj_move[j]==false and
                   obj_sleep_count[j]==0) 
                {
              
               //*****//
                if (obj[j].x==p_x and //1 нюкаем сверху
                    obj[j].y==p_y+1 and
                    p_vector_nuke==3 and
                    obj_nuke[j]==false)
                  {
                   obj_nuke[j]=true;
                   obj_nuke_count[j]=0;
                   p_score=p_score-10;
                   break;  
                  }    

                if (obj[j].x==p_x and //2 нюкаем снизу
                    obj[j].y==p_y-1 and
                    p_vector_nuke==1 and
                    obj_nuke[j]==false)
                  {
                   obj_nuke[j]=true;
                   obj_nuke_count[j]=0;
                   p_score=p_score-10;
                   break;  
                  }  

                if (obj[j].x==p_x-1 and//3 нюкаем слева
                    obj[j].y==p_y and
                    p_vector_nuke==4 and
                    obj_nuke[j]==false)
                  {
                   obj_nuke[j]=true;
                   obj_nuke_count[j]=0;
                   p_score=p_score-10;
                   break;  
                  }    

                if (obj[j].x==p_x+1 and//4 нюкаем справа
                    obj[j].y==p_y and
                    p_vector_nuke==2 and
                    obj_nuke[j]==false)
                  {
                   obj_nuke[j]=true;
                   obj_nuke_count[j]=0;
                   p_score=p_score-10;
                   break;  
                  }   

             }     
           }
      
         }//конец //блока управления игрой

         }         



       } 
     } 


    //Блок управления с клавиатуры
    keys = SDL_GetKeyState(NULL);

    //блок управления редактора
    if (edit==true)
     {
      //управление камерой
      if ( keys[SDLK_t] ) {y_cam=y_cam+3;} 
      if ( keys[SDLK_g] ) {y_cam=y_cam-3;} 
      if ( keys[SDLK_f] ) {x_cam=x_cam+3;} 
      if ( keys[SDLK_h] ) {x_cam=x_cam-3;}
     }

//===игра====!
    if (edit==false) 
     {

if (p_true==true) // Если колобок жив от им можно управлять
 {

   if ( keys[SDLK_LEFT] ) {p_vector_nuke=4;} 
   if ( keys[SDLK_RIGHT] ) {p_vector_nuke=2;} 
   if ( keys[SDLK_UP] ) {p_vector_nuke=1;} 
   if ( keys[SDLK_DOWN] ) {p_vector_nuke=3;}


   //Управляем колобком колобка
    if (keys[SDLK_LEFT] and p_move_stage==0)  
     {
      if (p_move_left_v==true ) 
       {
        p_move_left_v=false;
        p_move_left=true;
        p_vector=4;
        p_move_stage=1;
       
        p_frame=3;       

        p_move_right=false;
        p_move_up=false;
        p_move_down=false;
       } 
     }

    if (keys[SDLK_RIGHT] and p_move_stage==0)
     {
      if (p_move_right_v==true) 
       {
        p_move_right_v=false;
        p_move_right=true;
        p_vector=2;
        p_move_stage=1;
        
        p_frame=5;

        p_move_left=false;
        p_move_up=false;
        p_move_down=false;
       } 
     } 

    if (keys[SDLK_UP] and p_move_stage==0)
     {
      if (p_move_up_v==true) 
       {
        p_move_up_v=false;
        p_move_up=true;
        p_vector=1;
        p_move_stage=1;

        if (p_vector_old_left_right==4) {p_frame=3;}//было раньше лево
        if (p_vector_old_left_right==2) {p_frame=5;}//было раньше право

        p_move_right=false;
        p_move_left=false;
        p_move_down=false;
       }
     }
    
    if (keys[SDLK_DOWN]and p_move_stage==0) 
     {
      if (p_move_down_v==true) 
       {
        p_move_down_v=false;
        p_move_down=true;
        p_vector=3;
        p_move_stage=1;

        if (p_vector_old_left_right==4) {p_frame=3;}//было раньше лево
        if (p_vector_old_left_right==2) {p_frame=5;}//было раньше право

        p_move_right=false;
        p_move_left=false;
        p_move_up=false;
       } 
     } 

 //если колобок не может дальше пройти то он корчит рожи
/*    if (keys[SDLK_LEFT] and p_move_left_v==false) {p_frame=7;}
    if (keys[SDLK_RIGHT] and p_move_right_v==false) {p_frame=8;}
*/


 //стоим тупо улыбаемся когда клавиши управления не нажаты
  if (/*keys==0*/
      keys[SDLK_UP]==false and
      keys[SDLK_DOWN]==false and 
      keys[SDLK_LEFT]==false and 
      keys[SDLK_RIGHT]==false and 
      p_move_stage==0) 
   {
    p_frame=1;
   }

 }

if (p_move_stage==1) //стадия передвижения
 { 
  //вверх
  if (p_move_up==true and
      p_vector==1) 
   {
    p_move_y=p_move_y-0.08*grid;//скорость продвижения между клетками 

    if (p_move_y<-grid) //окончание передвижения
     {
      p_y=p_y-1;//после передвижения передвигаемся на новую клетку физически
      p_move_y=0;
      p_move_up=false;
      p_vector=0;
      p_move_stage=0;
     }
   }
  //вниз
  if (p_move_down==true and
      p_vector==3) 
   {
    p_move_y=p_move_y+0.08*grid;//скорость продвижения между клетками
 
    if (p_move_y>grid) //окончание передвижения
     {
      p_y=p_y+1;//после передвижения передвигаемся на новую клетку физически
      p_move_y=0;
      p_move_down=false;
      p_vector=0;
      p_move_stage=0;
     }
   }
  //влево
  if (p_move_left==true and
      p_vector==4) 
   {
    p_move_x=p_move_x-0.08*grid;//скорость продвижения между клетками

    if (p_move_x<-grid) //окончание передвижения
     {
      p_x=p_x-1;//после передвижения передвигаемся на новую клетку физически
      p_move_x=0;
      p_move_left=false;
      p_vector_old_left_right=p_vector;
      p_vector=0;
      p_move_stage=0;
     }
   }
  //вправо
  if (p_move_right==true and
      p_vector==2) 
   {
    p_move_x=p_move_x+0.08*grid;//скорость продвижения между клетками

    if (p_move_x>grid) //окончание передвижения
     {
      p_x=p_x+1;//после передвижения передвигаемся на новую клетку физически
      p_move_x=0;
      p_move_right=false;
      p_vector_old_left_right=p_vector;
      p_vector=0;
      p_move_stage=0;
     }
   }
//анимация в движении

//подглючивает анимация
  p_frame_count=p_frame_count+1; //задержка в шаге смене кадров

  if (p_frame_count>=4) 
   {
    p_frame_count=0;
    p_frame=p_frame+1;//смена кадра
       
    //Если колобок движется влево или вправо
    if (p_move_left==true and
        p_vector==4 and
        p_frame>4) {p_frame=3;}


    if (p_move_right==true and
        p_vector==2 and 
        p_frame>6) {p_frame=5;}
 
    //если колобок движется вверх или вниз то
    if (p_move_up==true and p_vector==1 or 
        p_move_down==true and p_vector==3)
     {
      if (p_vector_old_left_right==4 and p_frame>4) {p_frame=3;}//было раньше лево
      if (p_vector_old_left_right==2 and p_frame>6) {p_frame=5;}//было раньше право
     }
  
   }

 }//конец стадии передвижения 1







//Ограничение передвижения колобка внутри монитора-границы игрового экрана
    if (edit==false)//если отключен режим редактора то привязка камеры к клавиатуре отменяется 
     {
      if ((p_x*grid+x_cam)>(win_DX-7*grid)) 
       {x_cam=x_cam-0.1*grid;}
      if ((p_x*grid+x_cam)<(0+7*grid)) 
       {x_cam=x_cam+0.1*grid;}
      if ((p_y*grid+y_cam)>(win_DY-4*grid)) 
       {y_cam=y_cam-0.1*grid;}
      if ((p_y*grid+y_cam)<(0+4*grid)) 
       {y_cam=y_cam+0.1*grid;}
     }  
//Ограничение передвижения колобка внутри игрового чистого поля
      if (p_x>lev_width) {p_x=lev_width;} 
      if (p_x<0) {p_x=0;}  
      if (p_y>lev_height) {p_y=lev_height;} 
      if (p_y<0) {p_y=0;}    

//Проверка возможности перемещения колобка на новую клетку когда вижение не просиходит
      p_move_left_v=true;
      p_move_right_v=true;
      p_move_up_v=true;
      p_move_down_v=true;
      //фильтрация возможностей для lev
      //слева
      if (lev_matrix[p_x-1][p_y]>2) {p_move_left_v=false;}
      //справа
      if (lev_matrix[p_x+1][p_y]>2) {p_move_right_v=false;}
      //сверху
      if (lev_matrix[p_x][p_y-1]>2) {p_move_up_v=false;}
      //снизу
      if (lev_matrix[p_x][p_y+1]>2) {p_move_down_v=false;}

      //Если заходим живым колобком на зеленый элемент lev (=1), то стираем его
      if (p_true==true and
          lev_matrix[p_x][p_y]==1)
       {
        lev_matrix[p_x][p_y]==0;//ХЗ надо ли, т.к. ниже уже есть обновление матрицы
        for(i=0; i < lev_num_max; i++) 
         {
          if (lev[i].x==p_x and 
              lev[i].y==p_y and
              lev[i].texture==1)
           {
            lev[i].texture=0;
            p_kal[i]=true;//оставляем кал
           }
         }  
       }

      //Если заходим живым колобком на элемент lev (=2), то выход из уровня
      if (p_true==true and
          lev_matrix[p_x][p_y]==2)
       {
        for(i=0; i < lev_num_max; i++) 
         {
          if (lev[i].x==p_x and 
              lev[i].y==p_y and
              lev[i].texture==2)
           {
           //выход если собрано нужное количество очков
            if (p_score>=lev[i].exit_score) //грузим следущий уровень
             {        
              num_level=num_level+1;
              InitGame();
              sprintf(buff,"level/lev%i.dat",num_level);
              fp=fopen(buff,"r");
              fread((char *)lev, sizeof(struct lev_type), lev_num_max, fp);
              fclose (fp); 

              sprintf(buff,"level/obj%i.dat",num_level);
              fp=fopen(buff,"r");
              fread((char *)obj, sizeof(struct obj_type), obj_num_max, fp);
              fclose (fp);
             }

           }
         }
       }

//Взаимодействие колобка с obj, также определяем границы движения колобка при этом 
    if (p_true==true)//если колобок живой
     {

      if (p_move_stage==0)//снимаем метки тычка
       {
        p_kick_left=false;
        p_kick_right=false;
  
        for(j=0; j < obj_num_max; j++) 
         {
          if (obj_move_kick_left_mark[j]==true) {obj_move_kick_left_mark[j]=false;}
          if (obj_move_kick_right_mark[j]==true) {obj_move_kick_right_mark[j]=false;} 
         }
       }

      
      for(j=0; j < obj_num_max; j++) 
       {
        //ищем объекты для тычка
        //слева
        if (obj[j].texture==2 and 
            obj[j].x==p_x-1 and 
            obj[j].y==p_y and 
            obj_move[j]==false and
            obj_move_left[j]==false)
         {
        
          obj_move_kick_left_mark[j]=true;//ставим метку
         
          if (obj_move_left_v[j]==true) 
           {  
            p_kick_left_obj_N=j;//берем индекс
            p_kick_left=true;
            p_move_left_v=true;
           }
          
          //если объект не может дальше двигатся то и колобок тоже
          if (obj_move_left_v[j]==false) {p_move_left_v=false;}

         }

        //справа
        if (obj[j].texture==2 and obj[j].x==p_x+1 and obj[j].y==p_y and 
            obj_move[j]==false and
            obj_move_right[j]==false)
         {

          obj_move_kick_right_mark[j]=true;//ставим метку

          if (obj_move_right_v[j]==true) 
           {  
            p_kick_right_obj_N=j;//берем индекс
            p_kick_right=true;
            p_move_right_v=true;
           }

          //если объект не может дальше двигатся то и колобок тоже
          if (obj_move_right_v[j]==false) {p_move_right_v=false;}

         }
       }   



      //Реализация тычка при движении объект влево
      if (p_kick_left==true and
          p_y==obj[p_kick_left_obj_N].y and
          p_kick_left_obj_N>=0 and //ГЛЮК С НУЛЕВЫМ ОБЪЕКТОМ если не ставить = то 0-ой объект не катится именно здесь!!!!
          p_move_left==true)
       {
        //если объект толкаем то дополнительно передвигаем чтобы придти раньше колобка     
        obj_move_x[p_kick_left_obj_N]=obj_move_x[p_kick_left_obj_N]-1;
        obj_move[p_kick_left_obj_N]=true;
        obj_move_left[p_kick_left_obj_N]=true;

        obj_rotate[p_kick_left_obj_N]=1;//крутится при движени

        obj_move_left_v[p_kick_left_obj_N]=false;

        p_kick_left=false; 
    
        p_kick_left_obj_N=0;
       }

      //Реализация тычка при движении объект вправо
      if (p_kick_right==true and
          p_y==obj[p_kick_right_obj_N].y and
          p_kick_right_obj_N>=0 and 
          p_move_right==true)
       {
        //если объект толкаем то дополнительно передвигаем чтобы придти раньше колобка     
        obj_move_x[p_kick_right_obj_N]=obj_move_x[p_kick_right_obj_N]+1;
        obj_move[p_kick_right_obj_N]=true;
        obj_move_right[p_kick_right_obj_N]=true;

        obj_rotate[p_kick_right_obj_N]=1;//крутится при движени

        obj_move_right_v[p_kick_right_obj_N]=false;

        p_kick_right=false;

        p_kick_right_obj_N=0;
       }

      
      //сверху
      if (obj_matrix[p_x][p_y-1]==2) {p_move_up_v=false;}
      //снизу
      if (obj_matrix[p_x][p_y+1]==2) {p_move_down_v=false;}
     
     }//конец если колобок существет




//Проверка возможности перемещения объекта на новую клетку когда движение не просиходит
//взаимодействие объектов между собой и уровнем

    for(j=0; j < obj_num_max; j++)
     {
      if (obj_move[j]==false and //ключ
          obj_matrix[obj[j].x][obj[j].y]>0)
       { 
        obj_move_left_v[j]=true;
        obj_move_right_v[j]=true;
        obj_move_up_v[j]=true;
        obj_move_down_v[j]=true;  
       
        obj_move_up_left_v[j]=true;
        obj_move_up_right_v[j]=true;
        obj_move_down_left_v[j]=true;
        obj_move_down_right_v[j]=true;

        //фильтрация возможностей для lev и OBJ 
        //слева
        if (lev_matrix[obj[j].x-1][obj[j].y]>0 or
            obj_matrix[obj[j].x-1][obj[j].y]>0) {obj_move_left_v[j]=false;}
        //справа
        if (lev_matrix[obj[j].x+1][obj[j].y]>0 or
            obj_matrix[obj[j].x+1][obj[j].y]>0) {obj_move_right_v[j]=false;}
        //сверху
        if (lev_matrix[obj[j].x][obj[j].y-1]>0 or
            obj_matrix[obj[j].x][obj[j].y-1]>0) {obj_move_up_v[j]=false;}
        //снизу
        if (lev_matrix[obj[j].x][obj[j].y+1]>0 or
            obj_matrix[obj[j].x][obj[j].y+1]>0) {obj_move_down_v[j]=false;}

        //сверху слева
        if (lev_matrix[obj[j].x-1][obj[j].y-1]>0 or
            obj_matrix[obj[j].x-1][obj[j].y-1]>0) {obj_move_up_left_v[j]=false;}
        //сверху справа
        if (lev_matrix[obj[j].x+1][obj[j].y-1]>0 or
            obj_matrix[obj[j].x+1][obj[j].y-1]>0) {obj_move_up_right_v[j]=false;}
        //снизу слева
        if (lev_matrix[obj[j].x-1][obj[j].y+1]>0 or
            obj_matrix[obj[j].x-1][obj[j].y+1]>0) {obj_move_down_left_v[j]=false;}
        //снизу справа
        if (lev_matrix[obj[j].x+1][obj[j].y+1]>0 or
            obj_matrix[obj[j].x+1][obj[j].y+1]>0) {obj_move_down_right_v[j]=false;}
       }
      }


//проверка претендента на клетку 
    for(j=0; j < obj_num_max; j++)
    for(k=0; k < obj_num_max; k++)
     {
      //для всех типов объектов - ХЗ почему но если для 3-го типа не использовать, то можно раскрутить вихрем 1 и 2 тип 
      if (obj_matrix[obj[j].x][obj[j].y]>0 and
          obj_matrix[obj[k].x][obj[k].y]>0 /*and 
          obj_matrix[obj[j].x][obj[j].y]<3 and
          obj_matrix[obj[k].x][obj[k].y]<3*/) 
       { 
//чтобы в пропасть падали по одному, это правило будет действовать только при дырке в матрице уровня и объектов
      if (obj_move[j]==false and
          obj_move[k]==false and
          obj_move_right_v[j]==true and
          obj_move_left_v[k]==true and
          obj[j].y==obj[k].y and
          obj[j].x==obj[k].x-2 and 
          obj_matrix[obj[k].x-1][obj[k].y+1]==0 and 
          lev_matrix[obj[k].x-1][obj[k].y+1]==0 and   
          obj_index[k]!=p_kick_left_obj_N and
          obj_move_kick_left_mark[k]==false )
      
        {
          obj_move_left_v[k]=false; 
        }

//чтобы объекты ни слипались когда падают в пропасть, учитывали что может быть занята пропасть пролетающим вниз объектом, как работает ХЗ

      if (obj_move[j]==false and
          obj_move_right_v[j]==true and
          obj[j].y==obj[k].y+1 and
          obj[j].x==obj[k].x-1)
        {
          obj_move_right_v[j]=false;
        }

      if (obj_move[j]==false and
          obj_move_left_v[j]==true and
          obj[j].y==obj[k].y+1 and
          obj[j].x==obj[k].x+1)
        {
          obj_move_left_v[j]=false;
        }

       }
     }    



    for(j=0; j < obj_num_max; j++)
     {
      if (obj_move[j]==false and
          obj_sleep_count[j]>0)
       {
        obj_sleep_count[j]=obj_sleep_count[j]-1;
       }
     }     
 

// взаимодействие шарика с колобком - не взрыв, если колобок существует

    for(j=0; j < obj_num_max; j++)
     {
//1. объект (шарик) на колобке не проваливается
      if (p_true==true and
          obj_move[j]==false and
          obj_move_down_v[j]==true and
          obj_sleep_count[j]==0 and
          obj[j].texture>0 and //бонусы или шарики
          obj[j].texture<3 and
          obj[j].x==p_x and
          obj[j].y==p_y-1 and
          obj_matrix[p_x][p_y-1]>0)//в этой клетке действительно есть объект
       {
        obj_move_down_v[j]=false;
       }
//2. объект (шарик) не катится влево на колобка если под колобком яма 
      if (p_true==true and
          obj_move[j]==false and
          obj_move_left_v[j]==true and
          obj[j].texture>0 and //бонусы или шарики
          obj[j].texture<3 and
          obj[j].x==p_x+1 and
          obj[j].y==p_y and
          obj_matrix[p_x+1][p_y]>0)//в этой клетке действительно есть объект
       {
        obj_move_left_v[j]=false;
       }
//3. объект (шарик) не катится влево на колобка если под колобком яма 
      if (p_true==true and
          obj_move[j]==false and
          obj_move_right_v[j]==true and
          obj[j].texture>0 and //бонусы или шарики
          obj[j].texture<3 and
          obj[j].x==p_x-1 and
          obj[j].y==p_y and
          obj_matrix[p_x-1][p_y]>0)//в этой клетке действительно есть объект
       {
        obj_move_right_v[j]=false;
       }

//4. объект (шарик) не катится влево на колобка если он в яме 
      if (p_true==true and
          obj_move[j]==false and
          obj_move_left_v[j]==true and
          obj_move_down_left_v[j]==true and
          obj[j].texture>0 and //бонусы или шарики
          obj[j].texture<3 and
          obj[j].x==p_x+1 and
          obj[j].y==p_y-1 and
          obj_matrix[p_x+1][p_y-1]>0)//в этой клетке действительно есть объект
       {
        obj_move_left_v[j]=false;
        obj_move_down_left_v[j]=false;
       }

//5. объект (шарик) не катится вправо на колобка если он в яме
      if (p_true==true and
          obj_move[j]==false and
          obj_move_right_v[j]==true and
          obj_move_down_right_v[j]==true and
          obj[j].texture>0 and //бонусы или шарики
          obj[j].texture<3 and
          obj[j].x==p_x-1 and
          obj[j].y==p_y-1 and
          obj_matrix[p_x-1][p_y-1]>0)//в этой клетке действительно есть объект
       {
        obj_move_right_v[j]=false;
        obj_move_down_right_v[j]=false;
       }


     }


// старт для движений объектов-определяем поведение
    for(j=0; j < obj_num_max; j++)
     {
      //для элемента 1,2 OBJ
      if (obj_matrix[obj[j].x][obj[j].y]==1 or
          obj_matrix[obj[j].x][obj[j].y]==2)
       {
        //1. падение вниз
        if (obj_move[j]==false and
            obj_move_down[j]==false and
            obj_move_down_v[j]==true)
         {
          obj_move[j]=true;
          obj_move_down[j]=true;
          obj_move_down_v[j]=false;
          //на время движения новая клетка заранее занимается
          obj_matrix[obj[j].x][obj[j].y+1]=obj_matrix[obj[j].x][obj[j].y];  
         }

        //2. падение влево
        if (obj_move[j]==false and
            obj_move_left[j]==false and
            obj_move_left_v[j]==true and
            obj_move_down_left_v[j]==true)
         {
          obj_move[j]=true;
          obj_move_left[j]=true;
          obj_rotate[j]=1;//крутится при движении
          obj_move_left_v[j]=false;
          obj_move_down_left_v[j]=false;
          //на время движения новая клетка заранее занимается
          obj_matrix[obj[j].x-1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];  

         }

        //3. падение вправо
        if (obj_move[j]==false and
            obj_move_right[j]==false and
            obj_move_right_v[j]==true and
            obj_move_down_right_v[j]==true)
         {
          obj_move[j]=true;
          obj_move_right[j]=true;
          obj_rotate[j]=1;//крутится при движении 
          obj_move_right_v[j]=false;
          obj_move_down_right_v[j]=false;
          //на время движения новая клетка заранее занимается
          obj_matrix[obj[j].x+1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];
         }
       } 
    
      //для элемента 3 OBJ
      if (obj_matrix[obj[j].x][obj[j].y]==3)
       {
        if (obj_move[j]==false) 
         {
          obj_AI_rnd[j]=rand()%4+1;//определяем куда двинутся случайно
          obj_rotate[j]=2;//все время крутится
         }
    
        if (obj_move[j]==false and
            obj_AI_rnd[j]==1 and 
            obj_move_up[j]==false and
            obj_move_up_v[j]==true) 
         {
          obj_move[j]=true;
          obj_move_up[j]=true;
          obj_move_up_v[j]=false;
          //на время движения новая клетка заранее занимается
          obj_matrix[obj[j].x][obj[j].y-1]=obj_matrix[obj[j].x][obj[j].y];  
         } 
    
        if (obj_move[j]==false and
            obj_AI_rnd[j]==2 and 
            obj_move_down[j]==false and
            obj_move_down_v[j]==true) 
         {
          obj_move[j]=true;
          obj_move_down[j]=true;
          obj_move_down_v[j]=false;
          //на время движения новая клетка заранее занимается
          obj_matrix[obj[j].x][obj[j].y+1]=obj_matrix[obj[j].x][obj[j].y];
         }          
       
        if (obj_move[j]==false and
            obj_AI_rnd[j]==3 and 
            obj_move_left[j]==false and
            obj_move_left_v[j]==true) 
         {
          obj_move[j]=true;
          obj_move_left[j]=true;
          obj_move_left_v[j]=false;
          //на время движения новая клетка заранее занимается
          obj_matrix[obj[j].x-1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];
         }         

        if (obj_move[j]==false and
            obj_AI_rnd[j]==4 and 
            obj_move_right[j]==false and
            obj_move_right_v[j]==true) 
         {
          obj_move[j]=true;
          obj_move_right[j]=true;
          obj_move_right_v[j]=false;
          //на время движения новая клетка заранее занимается
          obj_matrix[obj[j].x+1][obj[j].y]=obj_matrix[obj[j].x][obj[j].y];
         }         

       } 
     }

//анимация и движение объектов
    for(j=0; j < obj_num_max; j++)
     {
      //для элемента OBJ
      if (obj_matrix[obj[j].x][obj[j].y]>0) 
       {
/*
        if (obj_move[j]==false)
         {
          obj_old_x[j]=obj[j].x;
          obj_old_y[j]=obj[j].y;
         }
*/

      //1. полет вверх
        if (obj_move_up[j]==true and
            obj_move[j]==true)
         {
          obj_move_y[j]=obj_move_y[j]-(grid/32)*100/fps;//скорость продвижения между клетками
          if (obj_move_y[j]<-grid) //окончание передвижения
           {
            obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
            obj[j].y=obj[j].y-1;//после передвижения передвигаемся на новую клетку физически
            obj_move_y[j]=0;
            obj_move_up[j]=false;
            obj_move[j]=false;
           }
         }

      //2. падение вниз
        if (obj_move_down[j]==true and
            obj_move[j]==true)
         {
          obj_move_y[j]=obj_move_y[j]+(grid/32)*100/fps;//скорость продвижения между клетками
          if (obj_move_y[j]>grid) //окончание передвижения
           {
            obj_sleep_count[j]=5;
            obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
            obj[j].y=obj[j].y+1;//после передвижения передвигаемся на новую клетку физически
            obj_move_y[j]=0;
            obj_move_down[j]=false;
            obj_move[j]=false;
           }
         } 


      //3. влево
        if (obj_move_left[j]==true and
            obj_move[j]==true)
         {
          obj_move_x[j]=obj_move_x[j]-(0.15*grid);//скорость продвижения между клетками

          if (obj_rotate[j]==1)//крутится при движении
           {
            obj_delta[j]=obj_delta[j]+(360/grid)*(0.15*grid);//объект катится

           }
          if (obj_move_x[j]<-grid) //окончание передвижения
           {
            obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
            obj[j].x=obj[j].x-1;//после передвижения передвигаемся на новую клетку физически
            obj_move_x[j]=0;
            obj_move_left[j]=false;
            obj_move[j]=false;
            
            if (obj_rotate[j]==1) 
             {
              obj_rotate[j]=0;
              if (obj_delta[j]>360) {obj_delta[j]=0;}
             }
 
           }
         } 
      //4. вправо
        if (obj_move_right[j]==true and
            obj_move[j]==true)
         {
          obj_move_x[j]=obj_move_x[j]+(0.15*grid);//скорость продвижения между клетками
          if (obj_rotate[j]==1)//крутится при движении
           {
            obj_delta[j]=obj_delta[j]-(360/grid)*(0.15*grid);//объект катится
           }
          if (obj_move_x[j]>grid) //окончание передвижения
           {
            obj_matrix[obj[j].x][obj[j].y]=0;//затираем старую матрицу
            obj[j].x=obj[j].x+1;//после передвижения передвигаемся на новую клетку физически
            obj_move_x[j]=0;
            obj_move_right[j]=false;
            obj_move[j]=false;

            if (obj_rotate[j]==1) 
             {
              if (obj_delta[j]<-360) {obj_delta[j]=0;}
              obj_rotate[j]=0;
             }

           }
         } 
      


       } 
     }


//метка hren1

   //Собираем очки
   //Если заходим колобком на элемент OBJ (=1), то стираем его
    for(j=0; j < obj_num_max; j++) 
     {

/*
      if (obj_move[j]==false and//обездвижены-для снятия артевактов с матрицы
          obj[j].texture==1 and 
          obj[j].x==p_x and 
          obj[j].y==p_y and 
          obj_matrix[obj[j].x][obj[j].y]==1) 
       {
        obj_matrix[p_x][p_y]=0;//стираем объект из матрицы объектов
       
        obj_dead[j]=true;//объект мертв
        p_score=p_score+1;//начисляем очки за поедание
       }
*/
  

      if (p_true==true and
          obj_dead[j]==false and
          //obj_sleep_count[j]>0 and          
          //obj_move[j]==false and//обездвижены-для снятия артевактов с матрицы
          obj[j].texture==1 and 
          p_x*grid+p_move_x-grid/3<obj[j].x*grid+obj_move_x[j]+grid/3 and
          p_x*grid+p_move_x+grid/3>obj[j].x*grid+obj_move_x[j]-grid/3 and
          p_y*grid+p_move_y-grid/3<obj[j].y*grid+obj_move_y[j]+grid/3 and
          p_y*grid+p_move_y+grid/3>obj[j].y*grid+obj_move_y[j]-grid/3)
           {
            obj_matrix[p_x][p_y]=0;//стираем объект из матрицы объектов

          obj_matrix[obj[j].x][obj[j].y]=0; 
    /*        obj_matrix[obj_old_x[j]][obj_old_y[j]]=0;//затираем старое место положение 
    */
          //если объект двигался
            if (obj_move[j]==true)
             {
              if (obj_move_up[j]==true) {obj_matrix[obj[j].x][obj[j].y-1]=0;}
              if (obj_move_down[j]==true) {obj_matrix[obj[j].x][obj[j].y+1]=0;}
              if (obj_move_left[j]==true) {obj_matrix[obj[j].x][obj[j].y-1]=0;}
              if (obj_move_right[j]==true) {obj_matrix[obj[j].x][obj[j].y+1]=0;}
             }

            obj_dead[j]=true;//объект мертв
            p_score=p_score+1;//начисляем очки за поедание
    
           }

     }



//метка hren2


    for (j=0; j < obj_num_max; j++)   
    for (k=0;k<eff_num_max;k++)//для начального усолвие для взрыва
     { 
      if (p_true==true and //столкновение с вихрем
          obj_dead[j]==false and
          obj[j].texture==3 and
/*
      player_x-31<x1_obj*setka+move_obj_x+setka/2+obj_dx/2
      player_x+31>x1_obj*setka+move_obj_x-setka/2-obj_dx/2
*/
          p_x*grid+p_move_x-grid/2<obj[j].x*grid+obj_move_x[j]+grid/2 and
          p_x*grid+p_move_x+grid/2>obj[j].x*grid+obj_move_x[j]-grid/2 and
          p_y*grid+p_move_y-grid/2<obj[j].y*grid+obj_move_y[j]+grid/2 and
          p_y*grid+p_move_y+grid/2>obj[j].y*grid+obj_move_y[j]-grid/2 and

          eff_true[k]==false 

          or  

          p_true==true and
          obj_sleep_count[j]>0 and //объект активен
          obj_dead[j]==false and //если объект существует
          obj_move[j]==true and //если объект движется
          obj_move_down[j]==true and //движется вниз
          obj[j].texture==2 and //дохнет от шарика 
    
          obj[j].x==p_x and
          obj[j].y==p_y-1 and  
          obj_matrix[p_x][p_y-1]==2 and//котнтроль по матрице объектов
    /*
          p_x*grid+p_move_x-grid/2<obj[j].x*grid+obj_move_x[j]+grid/2 and
          p_x*grid+p_move_x+grid/2>obj[j].x*grid+obj_move_x[j]-grid/2 and
          p_y*grid+p_move_y-grid/2<obj[j].y*grid+obj_move_y[j]+grid/2 and
          p_y*grid+p_move_y+grid/2>obj[j].y*grid+obj_move_y[j]-grid/2 and
    */
          eff_true[k]==false)
       {

/*

//Если бомба падает на бошку колобку то тратим его жизни
    for (j=0; j < obj_num_max; j++)   
    for (k=0;k<eff_num_max;k++)//начальное усолвие для взрыва
     { 
      if (p_true==true and
          obj_sleep_count[j]>0 and
          obj_dead[j]==false and
          obj_move[j]==true and
          obj_move_down[j]==true and 
          obj[j].texture==2 and //дохнет от шарика 
          obj[j].x==p_x and
          obj[j].y==p_y-1 and  
          obj_matrix[p_x][p_y-1]==2 and//котнтроль по матрице объектов
          eff_true[k]==false or//или же встречается с вихрем
          
          p_true==true and // по 1 взрыву получается
          obj_dead[j]==false and
          obj_move[j]==true and
          obj[j].texture==3 and //дохнет от вихря
          obj[j].x==p_x and
          obj[j].y==p_y and  
          obj_matrix[p_x][p_y]==3 and//котнтроль по матрице объектов
          eff_true[k]==false) 
       {
*/
        eff_true[k]=true;
        eff_type[k]=1;
        eff_W[k]=2*rand()%grid+2*grid;
        eff_H[k]=eff_W[k];
        eff_cR[k]=1;
        eff_cG[k]=1;
        eff_cB[k]=1;

        eff_cAlpha[k]=1;
       
        eff_counter[k]=1;
        eff_x[k]=p_x*grid+(rand()%45+1)-(rand()%45+1);
        eff_y[k]=p_y*grid+(rand()%45+1)-(rand()%45+1);

        //отнимаем у колобка жизнь 
        p_live=p_live-1;
        if (p_live==0)//будет 21 взрыв на месте крушения 
         {
          p_live=0; 
          p_true=false;//колобок больше не существует - не жилец:(
         } 

        break; 
 
       }
 
     }



//Если ктото умер там взрыв - начальные данные - подобрали объект
    for (j=0; j < obj_num_max; j++)   
    for (k=0;k<eff_num_max;k++)//начальное усолвие для взрыва
     { 
      //как дохнут молекулы
      if (obj[j].texture==1 and
          obj_dead[j]==true and
          eff_true[k]==false) 
       {
         obj_dead[j]=false;//не существует

         eff_true[k]=true;
         eff_type[k]=2;
         eff_W[k]=2*rand()%grid+2*grid;
         eff_H[k]=eff_W[k];
         eff_cR[k]=1;
         eff_cG[k]=1;
         eff_cB[k]=1;

         eff_cAlpha[k]=1;  
   
         eff_counter[k]=1;
         eff_x[k]=obj[j].x*grid;
         eff_y[k]=obj[j].y*grid;
   
         obj[j].x=0;
         obj[j].y=0;
         obj[j].texture=0;
       }

      //как дохнут бомбы или вихри
      if (obj[j].texture==2 and
          obj_dead[j]==true and
          eff_true[k]==false or

          obj[j].texture==3 and
          obj_dead[j]==true and
          eff_true[k]==false) 
       {
         obj_dead[j]=false;//не существует

         eff_true[k]=true;
         eff_type[k]=1;
         eff_W[k]=5*rand()%grid+5*grid;
         eff_H[k]=eff_W[k];
         eff_cR[k]=1;
         eff_cG[k]=1;
         eff_cB[k]=1;

         eff_cAlpha[k]=1;  
   
         eff_counter[k]=1;
         eff_x[k]=obj[j].x*grid;
         eff_y[k]=obj[j].y*grid;
   
         obj[j].x=0;
         obj[j].y=0;
         obj[j].texture=0;
       }


     } 

  //взрыв бомбы и вихря
    for(j=0; j < obj_num_max; j++)
     {
      if (obj_move[j]==false and //обездвижены-для снятия артевактов с матрицы
          obj_nuke[j]==true )
       {
        obj_nuke_count[j]=obj_nuke_count[j]+1;
        if (obj_nuke_count[j]>20+rand()%10)
         {
          obj_nuke[j]=false;
          obj_nuke_count[j]=0;
          obj_matrix[obj[j].x][obj[j].y]=0;//стираем объект из матрицы объектов
          obj_dead[j]=true;//объект мертв

          //подрываем бомбы и вихри в округе
          for( k=0; k < obj_num_max; k++)
           {      
            if (obj[k].texture==2 and
                obj_dead[k]==false and
                obj_sleep_count[k]==0 or
 
                obj[k].texture==3 and
                obj_dead[k]==false) 
             {   
//радиус взрыва по 8 направлениям по часовой
//812
//703
//654

//1
              if (obj[k].x==obj[j].x and
                  obj[k].y==obj[j].y-1 and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 

//2
              if (obj[k].x==obj[j].x+1 and
                  obj[k].y==obj[j].y-1 and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 


//3
              if (obj[k].x==obj[j].x+1 and
                  obj[k].y==obj[j].y and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 

//4
              if (obj[k].x==obj[j].x+1 and
                  obj[k].y==obj[j].y+1 and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 

//5
              if (obj[k].x==obj[j].x and
                  obj[k].y==obj[j].y+1 and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 

//6
              if (obj[k].x==obj[j].x-1 and
                  obj[k].y==obj[j].y+1 and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 

//7
              if (obj[k].x==obj[j].x-1 and
                  obj[k].y==obj[j].y and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 

//8
              if (obj[k].x==obj[j].x-1 and
                  obj[k].y==obj[j].y-1 and
                  obj_matrix[obj[k].x][obj[k].y]==obj[k].texture and 
                  obj_nuke[k]==false)
               {
                obj_nuke[k]=true;
                obj_nuke_count[k]=0;
               } 


             } 
           }



         }
 
       }  
     }
  



}//конец ===игра====!





//рисуем задний фон
    glBindTexture( GL_TEXTURE_2D,background_texture[1]);
    DrawTXT (win_DX/2,win_DY/2,win_DX,win_DY,0,1);


    for(i=0; i < lev_num_max; i++) 
     {
     //рисуем нули после того как слопали-кал
      if (lev[i].texture==0 and
          p_kal[i]==true and//есл это кал
          lev[i].x*grid+x_cam>0-grid and
          lev[i].x*grid+x_cam<win_DX+grid and 
          lev[i].y*grid+y_cam>0-grid and
          lev[i].y*grid+y_cam<win_DY+grid) 
       {
        glBindTexture( GL_TEXTURE_2D, other_texture[1] );
        DrawTXT (lev[i].x*grid+x_cam,
                 lev[i].y*grid+y_cam,
                 grid,grid,0,1);  
       }
     //Рисуем сам уровень
     //Если элемент уровня существует и попадает в окно вывода-его выводим
      if (lev[i].texture>0 and
          lev[i].x*grid+x_cam>0-grid and
          lev[i].x*grid+x_cam<win_DX+grid and 
          lev[i].y*grid+y_cam>0-grid and
          lev[i].y*grid+y_cam<win_DY+grid) 
       {
        glBindTexture( GL_TEXTURE_2D, lev_texture[lev[i].texture] );
        DrawTXT (lev[i].x*grid+x_cam,
                 lev[i].y*grid+y_cam,
                 grid,grid,0,1);  


//hren5 если значок уровня дверь то на ней выводим количество очков на выход
        if (lev[i].texture==2)
         {
          sprintf(txt_tmp,"%i",lev[i].exit_score);//количество очков на выход
          GlTxt(grid/2,//16,
                grid/4,//8,
                fonts[1],txtColorWhite,txt_tmp, t_txt[4]);
          glColor4f(0,
                    0,
                    0,
                    0.5+0.01*(rand()%50+1));
          glBindTexture( GL_TEXTURE_2D, t_txt[4] );
          DrawTXT (lev[i].x*grid+x_cam,
                   lev[i].y*grid+y_cam,
                   grid,grid,0,1); 
          glColor4f(1,1,1,1);
         }
       }
     }


//hren3 сетка для проверки матрицы объектов 
/*
    for(j=0;j<lev_width+1;j++)
    for(k=0;k<lev_height+1;k++)
     {
      if (obj_matrix[j][k]==0)
       {
        glBindTexture( GL_TEXTURE_2D, obj_texture[5] );
        DrawTXT (j*32+x_cam,
                 k*32+y_cam,20,20,0,1); 
       }
     }
*/



// Рисуем объекты
    for(j=0; j < obj_num_max; j++) 
     {
     //Если элемент уровня существует(жив) и попадает в окно вывода-его выводим
      if (obj[j].texture>0 and
          obj_dead[j]==false and 
          obj[j].x*grid+x_cam>0-grid and
          obj[j].x*grid+x_cam<win_DX+grid and 
          obj[j].y*grid+y_cam>0-grid and
          obj[j].y*grid+y_cam<win_DY+grid) 
       {
          if (obj_rotate[j]==2)//крутится все время
           {
            obj_delta[j]=obj_delta[j]+(360/grid)*100/fps;//объект катится
            if (obj_delta[j]>360) {obj_delta[j]=0;}
           }

          glBindTexture( GL_TEXTURE_2D, obj_texture[obj[j].texture] );
          DrawTXT (obj[j].x*grid+obj_move_x[j]+x_cam,
                   obj[j].y*grid+obj_move_y[j]+y_cam,
                   grid+obj_nuke_count[j],
                   grid+obj_nuke_count[j],
                   obj_delta[j],1); 
       }
     }

//Рисуем колобка, если он жив
    if (p_true==true)
     {
      glBindTexture( GL_TEXTURE_2D, player_texture[p_frame] );
      DrawTXT (p_x*grid+p_move_x+x_cam,
               p_y*grid+p_move_y+y_cam,
               grid,grid,0,1); 
     }  

//Рисуем курсор редактора 
    if (edit==true)
     {  
      if (edit_mode==1) {glBindTexture( GL_TEXTURE_2D, lev_texture[num_texture] );}
      if (edit_mode==2) {glBindTexture( GL_TEXTURE_2D, obj_texture[num_texture] );}

      DrawTXT (x_cursor*grid+x_cam,
               y_cursor*grid+y_cam,
               grid,grid,0,1);
  
      delta=delta+1;
      if (delta>360) {delta=0;}  
      glBindTexture( GL_TEXTURE_2D, cursor_texture );
      DrawTXT (x_cursor*grid+x_cam,
               y_cursor*grid+y_cam,
               grid+5*sin(delta*3.142/180),
               grid+5*sin(delta*3.142/180),delta,1);  
     }


//рисуем эффекты
    for(i=0;i<eff_num_max;i++)
     {
      if (eff_true[i]==true)
       {
        eff_counter[i]=eff_counter[i]+1;//завязать с ФПС
        if (eff_counter[i]==20 and
            eff_type[i]==1) {eff_true[i]=false;} 
        if (eff_counter[i]==16 and
            eff_type[i]==2) {eff_true[i]=false;} 

        glBlendFunc(GL_SRC_ALPHA,GL_ONE);
        glColor4f(eff_cR[i], eff_cG[i],eff_cB[i],eff_cAlpha[i]);
        glBindTexture( GL_TEXTURE_2D, eff_texture[eff_type[i]][eff_counter[i]]);
        DrawTXT (eff_x[i]+x_cam,
                 eff_y[i]+y_cam,
                 eff_W[i],
                 eff_H[i],0,1); 
       glColor4f(1,1,1,1);
       glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
      } 
     }


//рисуем ХУД
    glBindTexture( GL_TEXTURE_2D, other_texture[3]);
    DrawTXT (0,0,512,64,0,0); 


//выводим лайв бар
      if (p_live>0)
       {     
        glBindTexture( GL_TEXTURE_2D, other_texture[2]);
        DrawTXT (50,
                 22,
                 p_live*10,
                 20,0,0); 
       } 

//выводим число очков-очень тормозно. такое надо творить вне цикла для генерации текстовых текстур
    glBindTexture( GL_TEXTURE_2D, obj_texture[1] );
    DrawTXT(27,25,20,20,0,1);
    
    if (edit==false)//количество очков съеденых колобком при игре
     {
      sprintf(txt_tmp,"%i",p_score);
      GlTxt(16,16,fonts[1],txtColorWhite,txt_tmp, t_txt[1]);
      glBindTexture( GL_TEXTURE_2D, t_txt[1] );
      DrawTXT(28,45,16,16,0,1);
     }

    if (edit==true)//в режиме редактора выводим
     {  
      sprintf(txt_tmp,"%i",exit_score);//количество очков на выход
      GlTxt(16,16,fonts[1],txtColorWhite,txt_tmp, t_txt[2]);
      glBindTexture( GL_TEXTURE_2D, t_txt[2] );
      DrawTXT(28,45,16,16,0,1);

     }
  
//hren6
//выводим номкп уровня
    sprintf(txt_tmp,"level:%i",num_level);//номер уровня
    GlTxt(70,16,fonts[1],txtColorWhite,txt_tmp, t_txt[3]);
    glBindTexture( GL_TEXTURE_2D, t_txt[3] );
    DrawTXT(45,10,70,16,0,0);

    SDL_GL_SwapBuffers();


}//конец великого РЕНДЕРА

    // Теперь можно стереть все сгенеренные текстуры и отключить SDL
    glDeleteTextures( 1, &player_texture[1] );
  
    SDL_Quit();
    
    return 0;

}//конец!

